<?php
/**
*
* @package mChat English language (AllCity)
* @version 1.2.6d of 14.02.2011
* @copyright (c) By Shapoval Andrey Vladimirovich (AllCity) ~ http://allcity.net.ru/
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
**/

/**
* DO NOT CHANGE!
*/
if (!defined('IN_PHPBB'))
{
  exit;
}

if (empty($lang) || !is_array($lang))
{
  $lang = array();
}

// DEVELOPERS PLEASE NOTE
//
// All language files should use UTF-8 as their encoding and the files must not contain a BOM.
//
// Placeholders can now contain order information, e.g. instead of
// 'Page %s of %s' you can (and should) write 'Page %1$s of %2$s', this allows
// translators to re-order the output of data while ensuring it remains correct
//
// You do not need this where single placeholders are used, e.g. 'Message %d' is fine
// equally where a string contains only two placeholders which are used to wrap text
// in a url you again do not need to specify an order e.g., 'Click %sHERE%s' is fine

$lang = array_merge($lang, array(

  // MCHAT
  'MCHAT_TITLE' => 'Mini-chat',
  'MCHAT_NOMESSAGEINPUT' => 'Not filled field Message!',
  'MCHAT_EDITINFO' => 'Edit the message and press OK.',
  'MCHAT_NOACCESS' => 'Access denied!',
  'MCHAT_EDIT' => 'Edit',
  'MCHAT_DELETE' => 'Remove',
  'MCHAT_ADD' => 'Send',
  'MCHAT_SMILES' => 'Smilies',
  'MCHAT_BBCODES' => 'BBCodes',
  'MCHAT_HELP' => '?',
  'MCHAT_HELP_INFO' => 'Forbidden: \n1. Swearing\n2. Advertise your site\n3. Leave several messages in succession\n4. Leave a pointless message\n5. Leave a message consisting of some Smiley',
  'MCHAT_LOAD' => 'Transmitting data...',
  'MCHAT_OK' => 'OK',
  'MCHAT_ERROR' => 'Error',
  'MCHAT_AUTOUPDATE' => 'Autoupdate every <b>%d</b> seconds.',
  'MCHAT_IP' => 'IP:',
  'MCHAT_NOMESSAGE' => 'No messages!',
  'MCHAT_NOJAVASCRIPT' => 'Your browser does not support JavaScript or JavaScript is disabled!',
  'MCHAT_FLOOD' => 'You cannot make another message so soon after your last.',
  'MCHAT_ENABLE' => 'Sorry, the mini-chat is currently unavailable.',
  'MCHAT_TOTALMESSAGES' => 'Total messages: <b>%s</b>',
  'MCHAT_ARCHIVENOMESSAGE' => 'Did you delete all messages on this page.',
  'MCHAT_ARCHIVE' => 'Archive',
  'MCHAT_DELCONFIRM' => 'Do you confirm removal?',
  'MCHAT_USESOUND' => 'On/Off sound?',
  'MCHAT_NOSMILE' => 'Smilies not found!',
  'MCHAT_CLEANED' => 'All messages are successfully removed.',
  'MCHAT_CLEAN' => '&curren;',
  'MCHAT_TOUSER' => 'Respond to user',
  'MCHAT_DELALLMESS' => 'Remove all messages?',

  // BBCode Font
  'MCHAT_FONTSIZE' => 'Font size:',
  'MCHAT_FONTTINY' => 'Tiny',
  'MCHAT_FONTSMALL' => 'Small',
  'MCHAT_FONTNORMAL' => 'Normal',
  'MCHAT_FONTLARGE' => 'Large',
  'MCHAT_FONTHUGE' => 'Huge',

  // DB INSTALL
  'MCHAT_INSTALLOK' => 'The database has been successfully installed.',
  'MCHAT_INSTALLERROR' => 'The database is not installed!',
  'MCHAT_UNINSTALLOK' => 'The database has been successfully removed.',
  'MCHAT_UNINSTALLERROR' => 'The database is not removed!'

));
?>