<?php
/**
*
* @package mChat Russian language (AllCity)
* @version 1.2.6d of 14.02.2011
* @copyright (c) By Shapoval Andrey Vladimirovich (AllCity) ~ http://allcity.net.ru/
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
**/

/**
* DO NOT CHANGE!
*/
if (!defined('IN_PHPBB'))
{
  exit;
}

if (empty($lang) || !is_array($lang))
{
  $lang = array();
}

// DEVELOPERS PLEASE NOTE
//
// All language files should use UTF-8 as their encoding and the files must not contain a BOM.
//
// Placeholders can now contain order information, e.g. instead of
// 'Page %s of %s' you can (and should) write 'Page %1$s of %2$s', this allows
// translators to re-order the output of data while ensuring it remains correct
//
// You do not need this where single placeholders are used, e.g. 'Message %d' is fine
// equally where a string contains only two placeholders which are used to wrap text
// in a url you again do not need to specify an order e.g., 'Click %sHERE%s' is fine

$lang = array_merge($lang, array(

  // MCHAT
  'MCHAT_TITLE' => 'Мини-чат',
  'MCHAT_NOMESSAGEINPUT' => 'Не заполнено поле сообщение!',
  'MCHAT_EDITINFO' => 'Отредактируйте сообщение и нажмите ОК.',
  'MCHAT_NOACCESS' => 'Доступ запрещен!',
  'MCHAT_EDIT' => 'Изменить',
  'MCHAT_DELETE' => 'Удалить',
  'MCHAT_ADD' => 'Отправить',
  'MCHAT_SMILES' => 'Смайлики',
  'MCHAT_BBCODES' => 'ББ-Коды',
  'MCHAT_HELP' => '?',
  'MCHAT_HELP_INFO' => 'Запрещено:\n1. Ругаться матом\n2. Рекламировать свои сайты\n3. Оставлять несколько сообщений подряд\n4. Оставлять бессмысленные сообщения\n5. Оставлять сообщения состоящие из одних смайлов',
  'MCHAT_LOAD' => 'Передача данных...',
  'MCHAT_OK' => 'OK',
  'MCHAT_ERROR' => 'Ошибка',
  'MCHAT_AUTOUPDATE' => 'Автообновление каждые <b>%d</b> секунд.',
  'MCHAT_IP' => 'IP:',
  'MCHAT_NOMESSAGE' => 'Сообщений нет!',
  'MCHAT_NOJAVASCRIPT' => 'Ваш браузер не поддерживает JavaScript или JavaScript отключен!',
  'MCHAT_FLOOD' => 'Вы не можете отправить следующее сообщение сразу после предыдущего.',
  'MCHAT_ENABLE' => 'Извините, но мини-чат в настоящий момент недоступен.',
  'MCHAT_TOTALMESSAGES' => 'Всего сообщений: <b>%s</b>',
  'MCHAT_ARCHIVENOMESSAGE' => 'Вы удалили все сообщения на этой странице.',
  'MCHAT_ARCHIVE' => 'Архив',
  'MCHAT_DELCONFIRM' => 'Вы подтверждаете удаление?',
  'MCHAT_USESOUND' => 'Вкл/Выкл звук?',
  'MCHAT_NOSMILE' => 'Смайлы не найдены!',
  'MCHAT_CLEANED' => 'Все сообщения успешно удалены.',
  'MCHAT_CLEAN' => '&curren;',
  'MCHAT_TOUSER' => 'Обратится к пользователю',
  'MCHAT_DELALLMESS' => 'Удалить все сообщения?',

  // BBCode Font
  'MCHAT_FONTSIZE' => 'Размер шрифта:',
  'MCHAT_FONTTINY' => 'Очень маленький',
  'MCHAT_FONTSMALL' => 'Маленький',
  'MCHAT_FONTNORMAL' => 'Нормальный',
  'MCHAT_FONTLARGE' => 'Большой',
  'MCHAT_FONTHUGE' => 'Огромный',

  // DB INSTALL
  'MCHAT_INSTALLOK' => 'База данных успешно установлена.',
  'MCHAT_INSTALLERROR' => 'База данных не установлена!',
  'MCHAT_UNINSTALLOK' => 'База данных успешно удалена.',
  'MCHAT_UNINSTALLERROR' => 'База данных не удалена!'

));
?>